module Types where

import Graphics.Gloss (Color)

data ColorScheme = RedScheme | BWScheme | FancyScheme
data RenderMode = RasterMode | VectorMode

data Options = Options
               { optColorScheme  :: ColorScheme
               , optRenderMode :: RenderMode
               , optBGColor :: Color
               , optSqSize :: Float
               , optInput :: FilePath
               }


data ViewerCtx = ViewerCtx
                 { vctxRenderMode :: RenderMode
                 , vctxColorScheme :: ColorScheme
                 , vctxBGColor :: Color
                 , vctxSqSize :: Float
                 , vctxValTblSize :: (Int, Int)
                 , vctxValTblData :: [((Int, Int), Int)]
                 , vctxMinMaxVal :: (Int, Int)
                 , vctxNodataVal :: Maybe Int
                 }
